<template>
	<div id="header">
		<div class="d-flex align-items-center">
			<div class="logo-wrapper d-flex align-items-center">
				<img class="logo" src="../../assets/img/lgm_logo.png" />
				<div class="ml-3 text-white d-md-block d-none">
					Lembaga Getah Malaysia
				</div>
			</div>
			<font-awesome-icon class="header-icon sidebar-toggle" icon="bars" />
			<div class="d-flex align-items-center">
				<!-- Start Of Notification Badge -->
				<router-link
					class="d-flex align-items-center position-relative"
					to="/dashboard/alert-logs"
				>
					<div class="position-relative">
						<font-awesome-icon class="alert-icon" icon="bell" />
						<span class="count-info text-white bg-red">{{
							totalNumberOfAlert
						}}</span>
					</div>
					<p class="d-none d-sm-block text-white pl-4 mr-5">
						You have {{ totalNumberOfAlert }} today alerts
					</p>
				</router-link>
				<!-- End Of Notification Badge -->

				<!-- Start/Stop DPNR Preparation Button -->
				<div class="position-relative d-none d-xl-block">
					<p class="text-white py-2 pl-2 v-line ml-5">Prep DPNR</p>
					<span class="text-white py-2 pl-2 v-line ml-5">{{
						prepDPNR.operatingMode !== undefined && prepDPNR.isActive
							? prepDPNR.operatingMode.replace("_", " ")
							: null
					}}</span>
				</div>
				<button
					class="btn mx-5 px-5 py-2 font-weight-500 d-none d-xl-block"
					:class="
						(!prepDPNR.isActive && prepDPNR.productId !== 'n/a') ||
						mode === 'semi-auto'
							? 'btn-grey'
							: 'btn-white'
					"
					type="button"
					:disabled="
						(!prepDPNR.isActive && prepDPNR.productId !== 'n/a') ||
						mode === 'semi-auto' ||
						env === 'cloud'
					"
					@click="toggleDpnrPreparationProcess"
				>
					{{
						prepDPNR && prepDPNR.productId !== undefined
							? prepDPNR.productId.toUpperCase()
							: ""
					}}
				</button>
				<!-- End Of Start/Stop DPNR Preparation Button -->

				<!-- Start/Stop Preparation ENR Button -->
				<div class="position-relative d-none d-xl-block">
					<p class="text-white py-2 pl-2 v-line ml-5">Prep ENR</p>
					<span class="text-white py-2 pl-2 v-line ml-5">{{
						prepENR.operatingMode !== undefined && prepENR.isActive
							? prepENR.operatingMode.replace("_", " ")
							: null
					}}</span>
				</div>
				<button
					class="btn btn-white mx-5 px-5 py-2 font-weight-500 d-none d-xl-block"
					:class="
						(!prepENR.isActive && prepENR.productId !== 'n/a') ||
						mode === 'semi-auto'
							? 'btn-grey'
							: 'btn-white'
					"
					type="button"
					:disabled="
						(!prepENR.isActive && prepENR.productId !== 'n/a') ||
						mode === 'semi-auto' ||
						env === 'cloud'
					"
					@click="toggleEnrPreparationProcess"
				>
					{{
						prepENR.productId !== undefined
							? prepENR.productId.toUpperCase()
							: ""
					}}
				</button>
				<!-- End Of Start/Stop Preparation ENR Start Button -->

				<!-- Start/Stop Production Button -->
				<div class="position-relative d-none d-xl-block">
					<p class="text-white py-2 pl-2 v-line ml-5">Production</p>
					<span class="text-white py-2 pl-2 v-line ml-5">{{
						prod.operatingMode !== undefined && prod.isActive
							? prod.operatingMode.replace("_", " ")
							: null
					}}</span>
				</div>
				<button
					class="btn btn-white ml-5 px-5 py-2 font-weight-500 d-none d-xl-block"
					:class="
						(!prod.isActive && prod.productId !== 'n/a') || mode === 'semi-auto'
							? 'btn-grey'
							: 'btn-white'
					"
					type="button"
					:disabled="
						(!prod.isActive && prod.productId !== 'n/a') ||
						mode === 'semi-auto' ||
						env === 'cloud'
					"
					@click="toggleProductionProcess"
				>
					{{ prod.productId !== undefined ? prod.productId.toUpperCase() : '' }}
				</button>
				<!-- End Of Start/Stop Production Button -->
			</div>
		</div>
		<div class="d-flex align-items-center">
			<font-awesome-icon
				v-if="showPendingProcessIcon()"
				class="warning-icon blinking"
				icon="exclamation-triangle"
				@click="showModal('selectPendingProcessModal')"
			/>
			<img class="ml-5 tanand-logo" src="../../assets/img/tanand_header.png" />
		</div>

		<!-- Modal to choose process to start pending process -->
		<modal-component
			v-cloak
			id="select-pending-process-modal"
			ref="selectPendingProcessModal"
			@close="selectedPendingProcess = null"
		>
			<template v-slot:header> Select Process </template>
			<template v-slot:body>
				<div class="process-type">
					<div
						v-if="
							pendingPrepEnrProcess && pendingPrepEnrProcess.action !== 'none'
						"
						@click="setPendingProcessType('prepEnr')"
					>
						<span
							>{{
								pendingPrepEnrProcess.productId || "ENR-25"
							}}
							Preparation</span
						>
						<span v-if="selectedPendingProcess === 'prepEnr'">
							<font-awesome-icon
								class="check-square-icon"
								icon="check-square"
							/>
						</span>
					</div>

					<div
						v-if="
							pendingPrepDpnrProcess && pendingPrepDpnrProcess.action !== 'none'
						"
						@click="setPendingProcessType('prepDpnr')"
					>
						<span>DPNR Preparation</span>
						<span v-if="selectedPendingProcess === 'prepDpnr'">
							<font-awesome-icon
								class="check-square-icon"
								icon="check-square"
							/>
						</span>
					</div>

					<div
						v-if="pendingProdProcess && pendingProdProcess.action !== 'none'"
						@click="setPendingProcessType('prod')"
					>
						<span>{{ pendingProdProcess.productId }} Production</span>
						<span v-if="selectedPendingProcess === 'prod'">
							<font-awesome-icon
								class="check-square-icon"
								icon="check-square"
							/>
						</span>
					</div>
				</div>
				<div
					v-if="showPendingProcessError"
					class="error-message text-center mt-3"
				>
					{{ pendingProcessErrorMessage }}
				</div>
			</template>
			<template v-slot:footer>
				<div class="d-flex justify-content-center align-items-center">
					<button
						class="btn btn-blue px-4 py-2"
						style="width: 10rem"
						type="button"
						@click="goToPage"
					>
						Next
					</button>
					<button
						class="btn btn-grey ml-4 px-4 py-2"
						style="width: 10rem"
						type="button"
						@click="
							selectedPendingProcess = null;
							hideModal('selectPendingProcessModal');
						"
					>
						Cancel
					</button>
				</div>
			</template>
		</modal-component>
		<!-- End of modal to choose process to start pending process -->

		<!-- Start ENR preparation modal -->
		<modal-component
			v-cloak
			id="enr-preparation-modal"
			ref="enrPreparationModal"
			@close="selectedENRPreparationProcess = 'N/A'"
		>
			<template v-slot:header> Start Process </template>
			<template v-slot:body>
				<div class="process-type">
					<div
						v-for="processType in processTypes"
						:key="processType.id"
						v-show="processType.id !== 'DPNR'"
						@click="setEnrPreparationProcess(processType.id)"
					>
						<span>{{ processType.name }}</span>
						<span v-if="selectedENRPreparationProcess === processType.id">
							<font-awesome-icon
								class="check-square-icon"
								icon="check-square"
							/>
						</span>
					</div>
				</div>
				<div
					v-if="showStartEnrPreparationError"
					class="error-message text-center mt-3"
				>
					{{ startEnrPreparationErrorMessage }}
				</div>
			</template>
			<template v-slot:footer>
				<div class="d-flex justify-content-center align-items-center">
					<button
						class="btn btn-blue px-4 py-2"
						style="width: 10rem"
						type="button"
						@click="startEnrPreparationProcess"
					>
						Start
					</button>
					<button
						class="btn btn-grey ml-4 px-4 py-2"
						style="width: 10rem"
						type="button"
						@click="
							selectedENRPreparationProcess = 'N/A';
							hideModal('enrPreparationModal');
						"
					>
						Cancel
					</button>
				</div>
			</template>
		</modal-component>
		<!-- End of ENR preparation modal -->

		<!-- Start start production modal -->
		<modal-component
			v-cloak
			id="production-modal"
			ref="productionModal"
			@close="selectedProductionProcessType = 'N/A'"
		>
			<template v-slot:header>Start Process</template>
			<template v-slot:body>
				<div class="process-type">
					<div
						v-for="processType in processTypes"
						:key="processType.id"
						@click="setProductionProcessType(processType.id)"
						v-show="validateProcessAbleToStartForProduction(processType.id)"
					>
						<span>{{ processType.name }}</span>
						<span v-if="selectedProductionProcessType === processType.id">
							<font-awesome-icon
								class="check-square-icon"
								icon="check-square"
							/>
						</span>
					</div>
				</div>
				<div v-if="showProductionError" class="error-message text-center mt-3">
					{{ productionErrorMessage }}
				</div>
				<div v-if="noProcessAbleToStartForProduction()">
					No product available, please ensure preparation is performed.
				</div>
			</template>
			<template v-slot:footer v-if="!noProcessAbleToStartForProduction()">
				<div class="d-flex justify-content-center align-items-center">
					<button
						class="btn btn-blue mr-4 px-4 py-2"
						style="width: 10rem"
						type="button"
						@click="startProductionProcess"
					>
						Start
					</button>
					<button
						class="btn btn-grey px-4 py-2"
						style="width: 10rem"
						type="button"
						@click="hideModal('productionModal')"
					>
						Cancel
					</button>
				</div>
			</template>
		</modal-component>
		<!-- End of start production modal -->
	</div>
</template>

<script>
// Toggle sidebar.
import { toggleSidebar } from "@/utils/sidebar";
import ModalComponent from "../../components/modal/Modal";
import ProductService from "../../services/ProductService";
import { topics } from "@/utils/mqtt-topics";
import { mapFields } from "vuex-map-fields";
import ControlService from "@/services/ControlService";
import helperMixin from "@/mixins/helper";

export default {
	name: "header-component",
	components: {
		ModalComponent,
	},
	mixins: [helperMixin],
	data() {
		return {
			env: process.env.VUE_APP_ENV,
			accessCode: "",
			processTypes: ["DPNR", "ENR-25", "ENR-50"],
			startedPreparationProcessType: "N/A",
			selectedENRPreparationProcess: "",
			showStartEnrPreparationError: false,
			startEnrPreparationErrorMessage: "",
			startedProductionProcessType: "N/A",
			selectedProductionProcessType: "N/A",
			showProductionError: false,
			productionErrorMessage: "",
			showPendingProcessError: false,
			pendingProcessErrorMessage: "",
			device: {},
			totalNumberOfAlert: 0,
		};
	},
	methods: {
		/**
		 * Get product list
		 */
		getProductList() {
			let vm = this;

			this.productService.getProductList().then((result) => {
				if (typeof result.data !== "undefined") {
					vm.processTypes = result.data.data;
				}
			});
		},

		/**
		 * Toggle Start or Stop DPNR preparation process.
		 */
		toggleDpnrPreparationProcess() {
			// Check if DPNR preparation running or not.
			// If DPNR preparation still running display popup to confirm user want to stop the process or not.
			if (
				this.prepDPNR &&
				this.prepDPNR.productId !== "n/a" &&
				this.prepDPNR.isActive
			) {
				this.$swal({
					title: "End Process",
					text: "Confirm to end process DPNR preparation?",
					icon: "warning",
					showCancelButton: true,
					confirmButtonColor: "#d33",
					cancelButtonColor: "#727272",
					confirmButtonText: "Yes",
				}).then((result) => {
					if (!result.value) {
						return;
					}

					this.showLoadingOverlay();

					// Request API to stop DPNR Preparation process.
					this.controlService.stopBatch("prepDpnr").then((result) => {
						if (typeof result.response !== "undefined") {
							this.displayErrorPopup(result);
							return;
						}

						this.hideLoadingOverlay();
						this.displaySuccessPopup(
							"Successfully stop DPNR preparation process."
						);
						this.prepDPNR = { productId: "DPNR", isActive: false };
					});
				});

				return;
			}

			// Start DPNR Preparation process.
			this.$swal({
				title: "Confirmation",
				text: "Are you sure want to start DPNR Preparation?",
				icon: "warning",
				showCancelButton: true,
				confirmButtonColor: "#d33",
				cancelButtonColor: "#727272",
				confirmButtonText: "Yes",
			}).then((result) => {
				// If user cancel the confirmation, do nothing.
				if (!result.value) {
					return;
				}

				this.showLoadingOverlay();

				// Request API to start DPNR preparation process.
				this.controlService.startBatch("prepDpnr", "DPNR").then((result) => {
					if (typeof result.result !== "undefined") {
						this.displayErrorPopup(result);
						return;
					}

					this.prepDPNR = { productId: "DPNR", isActive: true };
					this.hideLoadingOverlay();
					this.displaySuccessPopup(
						"Successfully start DPNR preparation process."
					);
				});
			});
		},

		/**
		 * Set selected ENR preparation process.
		 * For ENR contains 2 process. User must select one of the process before can start the ENR preparation.
		 * - ENR-25
		 * - ENR-50
		 *
		 * @param processType
		 */
		setEnrPreparationProcess(processType) {
			if (this.selectedENRPreparationProcess === processType) {
				this.showStartEnrPreparationError = false;
				this.selectedENRPreparationProcess = "N/A";
				return;
			}

			this.showStartEnrPreparationError = false;

			this.selectedENRPreparationProcess = processType;
		},

		/**
		 * Toggle ENR preparation whether want to start or stop.
		 * If ENR preparation still running, stop the ENR preparation process.
		 * If ENR preparation not running, start ENR preparation process.
		 */
		toggleEnrPreparationProcess() {
			// Check if ENR preparation running or not.
			// If ENR preparation still running display popup whether user want to stop the process or not.
			if (
				this.prepENR &&
				this.prepENR.productId !== "n/a" &&
				this.prepENR.isActive
			) {
				this.$swal({
					title: "End Process",
					text:
						"Confirm to end process " +
						this.prepENR.productId +
						" preparation?",
					icon: "warning",
					showCancelButton: true,
					confirmButtonColor: "#d33",
					cancelButtonColor: "#727272",
					confirmButtonText: "Yes",
				}).then((result) => {
					// If user cancel the confirmation, do nothing.
					if (!result.value) {
						return;
					}

					this.showLoadingOverlay();

					// Request API to stop ENR preparation.
					this.controlService.stopBatch("prepEnr").then((result) => {
						if (typeof result.response !== "undefined") {
							this.displayErrorPopup(result);
							return;
						}

						this.hideLoadingOverlay();
						this.displaySuccessPopup(
							"Successfully stop " +
								this.prepENR.productId +
								" preparation process."
						);
						this.prepENR = {
							productId: this.prepENR.productId,
							isActive: false,
						};
					});
				});
			} else {
				// Show modal to start ENR preparation.
				this.showModal("enrPreparationModal");
			}
		},

		/**
		 * Start ENR preparation process.
		 */
		startEnrPreparationProcess() {
			// Check if user select one of the ENR process.
			// Show an error message if user didn't select any ENR process.
			if (this.selectedENRPreparationProcess === "") {
				this.startEnrPreparationErrorMessage =
					"Please select one of the ENR process.";
				this.showStartEnrPreparationError = true;
				return;
			}

			// Check if ENR production running or not.
			// If ENR production running, cannot start the ENR preparation.
			// Show an error message.
			if (this.selectedENRPreparationProcess === this.prod) {
				this.startEnrPreparationErrorMessage =
					"Cannot start " +
					this.selectedENRPreparationProcess +
					" preparation for while " +
					this.selectedENRPreparationProcess +
					" production is running.";
				this.showStartEnrPreparationError = true;
				return;
			}

			// Display popup to confirm start ENR preparation.
			this.$swal({
				title: "Confirmation",
				text:
					"Are you sure want to start " +
					this.selectedENRPreparationProcess +
					" Preparation?",
				icon: "warning",
				showCancelButton: true,
				confirmButtonColor: "#d33",
				cancelButtonColor: "#727272",
				confirmButtonText: "Yes",
			}).then((result) => {
				if (result.value) {
					this.showLoadingOverlay();

					// Request API to start the ENR preparation.
					this.controlService
						.startBatch("prepEnr", this.selectedENRPreparationProcess)
						.then((result) => {
							if (typeof result.response !== "undefined") {
								this.displayErrorPopup(result);
								return;
							}

							this.prepENR = {
								productId: this.selectedENRPreparationProcess,
								isActive: true,
							};
							let product = this.selectedENRPreparationProcess;
							this.selectedENRPreparationProcess = "";
							this.hideLoadingOverlay();

							// Hide ENR preparation popup after process has been started.
							this.hideModal("enrPreparationModal");

							this.displaySuccessPopup(
								"Successfully start " + product + " preparation process."
							);
						});
				} else {
					// Display again popup to start ENR preparation if user cancel the confirm popup.
					this.showModal("enrPreparationModal");
				}
			});
		},

		/**
		 * Set selected production process type.
		 *
		 * @param processType
		 */
		setProductionProcessType(processType) {
			if (this.selectedProductionProcessType === processType) {
				this.showProductionError = false;
				this.selectedProductionProcessType = "N/A";
				return;
			}

			this.showProductionError = false;
			this.selectedProductionProcessType = processType;
		},

		/**
		 * Toggle Start or Stop production process. For production, Able to start or stop 3 process.
		 * - ENR-25
		 * - ENR-50
		 * - DPNR
		 */
		toggleProductionProcess() {
			if (
				this.prod.isActive &&
				this.prod.productId !== "n/a" &&
				this.prod.isActive
			) {
				this.$swal({
					title: "End Process",
					text:
						"Confirm to end process " + this.prod.productId + " production?",
					icon: "warning",
					showCancelButton: true,
					confirmButtonColor: "#d33",
					cancelButtonColor: "#727272",
					confirmButtonText: "Yes",
				}).then((result) => {
					// If user cancel the confirmation, do nothing.
					if (!result.value) {
						return;
					}

					this.showLoadingOverlay();
					let productID = this.prod.productId;

					// Request the API to stop production process.
					this.controlService.stopBatch("prod").then((result) => {
						if (typeof result.response !== "undefined") {
							this.displayErrorPopup(result);
							return;
						}

						this.hideLoadingOverlay();
						this.displaySuccessPopup(
							"Successfully stop " + productID + " production process."
						);
						this.prod = { productId: "n/a", isActive: false };
					});
				});
			} else {
				// Show modal to start production process.
				this.showModal("productionModal");
			}
		},

		/**
		 * Start production process.
		 */
		startProductionProcess() {
			// Check if user select one of the production process.
			// Show an error message if user didn't select any production process.
			if (this.selectedProductionProcessType === "N/A") {
				this.productionErrorMessage = "Please select one of the process.";
				this.showProductionError = true;
				return;
			}

			// Display popup to confirm start of production process..
			this.$swal({
				title: "Confirmation",
				text:
					"Are you sure want to start " +
					this.selectedProductionProcessType +
					" Production?",
				icon: "warning",
				showCancelButton: true,
				confirmButtonColor: "#d33",
				cancelButtonColor: "#727272",
				confirmButtonText: "Yes",
			}).then((result) => {
				if (result.value) {
					this.showLoadingOverlay();
					// console.log(this.selectedProductionProcessType);
					// Request API to start the production process.
					this.controlService
						.startBatch("prod", this.selectedProductionProcessType)
						.then((result) => {
							if (typeof result.response !== "undefined") {
								this.displayErrorPopup(result);
								return;
							}

							this.prod = {
								productId: this.selectedProductionProcessType,
								isActive: true,
							};
							let product = this.selectedProductionProcessType;
							this.selectedProductionProcessType = "";
							this.hideLoadingOverlay();

							// Hide ENR preparation popup after process has been started.
							this.hideModal("productionModal");

							this.displaySuccessPopup(
								"Successfully start " + product + " production process."
							);
						});
				} else {
					// Display again popup to start production process if user cancel the confirm popup.
					this.showModal("productionModal");
				}
			});
		},

		/**
		 * Logic to display the pending process icon.
		 */
		showPendingProcessIcon() {
			if (
				this.pendingProdProcess &&
				this.pendingProdProcess.action !== "none"
			) {
				return true;
			}

			if (
				this.pendingPrepDpnrProcess &&
				this.pendingPrepDpnrProcess.action !== "none"
			) {
				return true;
			}

			if (
				this.pendingPrepEnrProcess &&
				this.pendingPrepEnrProcess.action !== "none"
			) {
				return true;
			}

			return false;
		},

		/**
		 * Set selected pending process type.
		 *
		 * @param processType
		 */
		setPendingProcessType(processType) {
			if (this.selectedPendingProcess === processType) {
				this.showPendingProcessError = false;
				this.selectedPendingProcess = null;
				return;
			}

			this.showPendingProcessError = false;
			this.selectedPendingProcess = processType;
		},

		/**
		 * Validate if user select one of the process.
		 * If not select show an error message.
		 * Otherwise go to the selected process page.
		 */
		goToPage() {
			// Check if user select one of the pending process.
			// Show an error message if user didn't select any pending process.
			if (!this.selectedPendingProcess) {
				this.pendingProcessErrorMessage = "Please select one of the process.";
				this.showPendingProcessError = true;
				return;
			}

			let dpnrPrepPath = "/dashboard/preparations/dpnr";
			let enr25PrepPath = "/dashboard/preparations/enr-25";
			let dpnrProdPath = "/dashboard/productions/dpnr";
			let enr25ProdPath = "/dashboard/productions/enr-25";

			if (
				this.selectedPendingProcess === "prepEnr" &&
				this.$route.path !== enr25PrepPath
			) {
				this.hideModal("selectPendingProcessModal");
				return this.$router.push(enr25PrepPath);
			}

			if (
				this.selectedPendingProcess === "prepDpnr" &&
				this.$route.path !== dpnrPrepPath
			) {
				this.hideModal("selectPendingProcessModal");
				return this.$router.push(dpnrPrepPath);
			}

			// TODO: Go to prod page due to system don't know the process. Cannot redirect user.
			if (this.selectedPendingProcess === "prod") {
				this.hideModal("selectPendingProcessModal");

				if (
					this.pendingProdProcess.productId === "DPNR" &&
					this.$route.path !== dpnrProdPath
				) {
					return this.$router.push(dpnrProdPath);
				}

				if (
					this.pendingProdProcess.productId === "ENR-25" &&
					this.$route.path !== enr25ProdPath
				) {
					return this.$router.push(enr25ProdPath);
				}
			}
			this.hideModal("selectPendingProcessModal");
		},

		/**
		 * Start pending process. API automatically run next process.
		 * Only pass the stage whether prepDpnr, prepEnr or prod.
		 */
		startPendingProcess() {
			this.showLoadingOverlay();

			// Request API to start the next batch process.
			this.controlService
				.startNextBatchProcess(this.selectedPendingProcess)
				.then((result) => {
					if (typeof result.response !== "undefined") {
						this.displayErrorPopup(result);
						return;
					}

					// Set pending process to none.
					if (this.selectedPendingProcess === "prepEnr") {
						this.pendingPrepEnrProcess = null;
					} else if (this.selectedPendingProcess === "prepDpnr") {
						this.pendingPrepDpnrProcess = null;
					} else if (this.selectedPendingProcess === "prod") {
						this.pendingProdProcess = null;
					}

					// clear selected pending process.
					this.selectedPendingProcess = null;

					this.hideModal("selectPendingProcessModal");
					this.hideModal("startPendingProcessModal");
					this.hideLoadingOverlay();
				});
		},

		/**
		 *  Validate which process can start for production.
		 *  Need to check the data inside /lgm/stage mqtt topic
		 */
		validateProcessAbleToStartForProduction(processType) {
			// Need to check prepDpnr and prepEnr.
			// Only those with productId !== "n/a" && isActive = false can start.

			if (
				processType === "DPNR" &&
				this.prepDPNR.productId !== "n/a" &&
				!this.prepDPNR.isActive
			) {
				return true;
			}

			if (
				processType === "ENR-25" &&
				this.prepENR.productId === "ENR-25" &&
				!this.prepENR.isActive
			) {
				return true;
			}

			if (
				processType === "ENR-50" &&
				this.prepENR.productId === "ENR-50" &&
				!this.prepENR.isActive
			) {
				return true;
			}

			return false;
		},

		/**
		 *  Get list of process length which process can start for production.
		 *  Need to check the data inside /lgm/stage mqtt topic
		 */
		noProcessAbleToStartForProduction() {
			// Need to check prepDpnr and prepEnr.
			// Only those with productId !== "n/a" && isActive = false can start.
			var availableProcess = [];

			this.processTypes.forEach((item) => {
				let processType = item.id;
				if (
					processType === "DPNR" &&
					this.prepDPNR.productId !== "n/a" &&
					!this.prepDPNR.isActive
				) {
					availableProcess.push(processType);
				} else if (
					processType === "ENR-25" &&
					this.prepENR.productId === "ENR-25" &&
					!this.prepENR.isActive
				) {
					availableProcess.push(processType);
				} else if (
					processType === "ENR-50" &&
					this.prepENR.productId === "ENR-50" &&
					!this.prepENR.isActive
				) {
					availableProcess.push(processType);
				}
			});

			return availableProcess.length === 0;
		},
	},

	/**
	 * Listen to MQTT topics.
	 * Using the plugin below.
	 * @see https://www.npmjs.com/package/vue-mqtt
	 */
	mqtt: {
		"lgm/stage"(message, topic) {
			// console.log(
			// 	`Header - ${new Date().toLocaleString()} ${topic} : ` +
			// 		message.toString()
			// );

			message = JSON.parse(message.toString());

			this.prepDPNR = message.prepDpnr;
			this.prepENR = message.prepEnr;
			this.prod = message.prod;
		},
		"lgm/pending/+"(message, topic) {
			// console.log(
			// 	`Header - ${new Date().toLocaleString()} ${topic} : ` +
			// 		message.toString()
			// );

			message = JSON.parse(message.toString());

			if (topic === "lgm/pending/prod") {
				this.pendingProdProcess = message;
			} else if (topic === "lgm/pending/prepDpnr") {
				this.pendingPrepDpnrProcess = message;
			} else if (topic === "lgm/pending/prepEnr") {
				this.pendingPrepEnrProcess = message;
			}
		},
	},
	computed: {
		/**
		 * The `mapFields` function takes an array of field names and generates corresponding
		 * computed properties with getter and setter functions for accessing the Vuex store.
		 */
		...mapFields([
			"pendingPrepEnrProcess",
			"pendingPrepDpnrProcess",
			"pendingProdProcess",
			"selectedPendingProcess",
			"prepDPNR",
			"prepENR",
			"prod",
			"mode",
		]),

		/**
		 * Create ProductService instance.
		 *
		 * @returns {ProductService}
		 */
		productService: function () {
			return new ProductService();
		},

		/**
		 * Create Automation Service instance.
		 *
		 * @returns {ControlService}
		 */
		controlService: function () {
			return new ControlService();
		},
	},
	mounted() {
		// Subscribe to mqtt topics.
		this.$mqtt.subscribe(topics.header, function (err, granted) {
			if (err) {
				console.log("\nHeader - Error During Subscription :" + err);
			} else {
				console.log("\nHeader - No Error During Subscription");
			}
			if (granted !== undefined) {
				granted.forEach(function (grant) {
					console.log("Header - Subscribed to topic " + grant.topic);
				});
			}
		});

		// Initialize click event for sidebar.
		toggleSidebar();

		// let alertService = new AlertService();

		// Get total number of alert.
		// alertService.countTotalAlert().then((response) => {
		//     if (typeof response.data !== 'undefined') {
		//         this.totalNumberOfAlert = response.data;
		//     }
		// });

		this.getProductList();
	},

	/**
	 * Unsubscribe topic before destroying the component.
	 * Call when you switch the route or go to another page.
	 */
	beforeDestroy() {
		if (this.topics && this.topics.length > 0) {
			this.$mqtt.unsubscribe(this.topics);
		}
	},
};
</script>

<style lang="scss" scoped>
@import "../../assets/styles/layouts/header.scss";
</style>
